# -*- mode: landisk-python; coding: utf-8; -*-
# vim:ts=4 sw=4 sts=4 ai si et sta
from django.utils.translation import ugettext as _
from django import forms
from django.core.exceptions import ValidationError
from project.view import FuncView
from project.forms.fields.extras.enable import EnableField
from project.forms.fields.extras.fqdn import FQDNField
from project.forms.fields.extras.landiskpass import LanDiskPassField
from project.fal.clone import Clone


class View(FuncView):

    class Form(forms.Form):
        pass

    views = ['execute']

#    def _is_ok(self):
#        try:
#            return Clone().query()['slave']['switch']
#        except:
#            return False

    def _info(self):
        try:
            data = Clone().query()
            return {
                'hostname': data['saveconfig']['switch']['hostname'],
                'timestamp': data['saveconfig']['switch']['timestamp'],
                'lan1': {
                    'ipv4': data['saveconfig']['switch']['ipaddr']['lan1']['ipv4'],
                    'ipv6': data['saveconfig']['switch']['ipaddr']['lan1']['ipv6'],
                },
                'lan2': {
                    'ipv4': data['saveconfig']['switch']['ipaddr']['lan2']['ipv4'],
                    'ipv6': data['saveconfig']['switch']['ipaddr']['lan2']['ipv6'],
                },
            }
        except:
            return {}

    def view(self, request):
        form = self.Form()
        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'from': form,
                'info': self._info(),
                #'ok': self._is_ok(),
            },
        }

    def view_execute(self, request):
        with self.processing() as p:
            form = self.Form(data=request.POST)
            p.break_if_state_change()

            if form.is_valid():
                clone = Clone()
                p.result(clone.switch())
                self.set_message(clone.get_message())
                if p.result():
                    self.set_message(_(u"LanDiskClone: Please wait until STATUS lump blinking stop."))

        return {
            self.KEY_TEMPLATE: self.TEMPLATE,
            self.KEY_TEMPLATE_DIC: {
                'form': form,
                'info': self._info(),
                #'ok': self._is_ok(),
            },
        }
